proc com_base {nom} {
global p 
global q

if {$nom == "non"} {
    CMD non $p
} else {
    CMD $nom $p $q
}
}

proc mp {con} {
global p 
   CMD maxpropag $p $con 

}

proc maxloc {con} {
global p 
   CMD maxloc $p $con 

}

proc eroult {con} {
global p 
   CMD eroult $p $con 

}

proc fctdist {nom} {
global p
    CMD fctdist $p $nom
}


proc rec_geo {con} {
global p
global q

    CMD reconstruit $p $q $con
}

proc sk1p {type} {
global p 
global nbit

if {$type == 0} {
      CMD homot1pass $p 0
} else {
for {set i 1} {$i <= $nbit} {incr i} {
        CMD homot1pass $p $type
        update idletasks
}
}
}

proc skmb {} {
global p
global cx
global mb
global dist
global typ
global cornerflag

    if {$dist != 0} {
	if {$typ == 1} {CMD skdist $p mb$mb $dist $cornerflag}
	if {$typ == 2} {CMD skdistdir $p mb$mb $dist $cx $cornerflag}
    } else {
	if {$typ == 1} {CMD squel $p mb$mb $cornerflag}	
    }
}

proc ebarbul {} {
global p 
global nbit

for {set i 1} {$i <= $nbit} {incr i} {
 CMD ebarbule $p 
 update idletasks
}
 
}

proc skiz {} {
global p 
global nbit
global num

for {set i 0} {$i <= $nbit} {incr i} {
 incr num
 CMD skiz $p $num
 update idletasks
}
} 
 
proc skiz_geo {cx} {
global p 
global q

 CMD skiz_geo $p $q $cx
 update idletasks
}

proc jach {} {
global p
global num
global nbit
 
for {set i 1} {$i <= $nbit} {incr i} {
 CMD jach $p $num
 update idletasks
 incr num
 }
}  
   
proc mbdir {type con} {
global p
global num
global nbit
global cornerflag
 
for {set i 1} {$i <= $nbit} {incr i} {
 CMD mbdir $p $type $con $num $cornerflag
 update idletasks
 incr num
 }
}
     
proc mbfp {type} {
global p
global nbit
global cornerflag
 
for {set i 1} {$i <= $nbit} {incr i} {
 CMD mbfp $p $type $cornerflag
 update idletasks
 }
}     

proc mbhybride {type con} {
global p
global nbit
global cornerflag

set cpt 0
for {set i 1} {$i <= $nbit} {incr i} {
    if {[expr abs($cpt + sqrt(2) - $i)] < [expr abs($cpt + sqrt(2)/2 - $i)]} {
	set cpt [expr $cpt + sqrt(2)]
	puts "Itration d8"
	for {set j 0} {$j < 4} {incr j} {
	    CMD mbdir $p $type $con $j $cornerflag
	    update idletasks
	}
    } else {
	set cpt [expr $cpt + sqrt(2)/2]
	puts "Itration d4"
	if {$con == 8} {
	    CMD mbfp $p $type $cornerflag  
	} else {
	    if {$type == "mb1"} {
		CMD latecki $p 1
	    } else {
		CMD latecki $p 2
	    }
	}
	update idletasks
    }
}
}     

proc stew {} {
global p
global nbit
 
for {set i 1} {$i <= $nbit} {incr i} {
 CMD stew $p
 update idletasks
 }
}

proc latecki {type} {
global p
global nbit
 
for {set i 1} {$i <= $nbit} {incr i} {
 CMD latecki $p $type
 update idletasks
 }
}
   
proc afp {type} {
global p
global nbit
 
for {set i 1} {$i <= $nbit} {incr i} {
 CMD afp $p $type
 update idletasks
 }
}       

proc skaff {} {
global p
global q
global nbit
global num
 
for {set i 1} {$i <= $nbit} {incr i} {
 #CMD squelaffich $p $q $num
   CMD non $p
   CMD skiz $p $num
   CMD non $p
   CMD ou $p $q
 update idletasks
 incr num
 }
}     