#ifndef _PROPAG_
#define _PROPAG_

// Calcul des points 8-simples (Nc8 = 1)
void point_simple(Image<int>& p,Image<int>& pres);

// Calcul du Crossing Number de Rutowitz (Xr' = 1)
void cross_number(Image<int>& p,Image<int>& pres);

// Calcul des points non extremes (#voisins > 2)
void vp3ouplus(Image<int>& p,Image<int>& pres);

// Calcul des maxima locaux de la fonction distance

 void maxpropag(Image<int>& p,int conex);

// Amincissements homotopiques
 
 void front_nord(Image<int>& p);
 void front_sud(Image<int>& p);
 void front_ouest(Image<int>& p);
 void front_est(Image<int>& p);

// Marquage homotopique
 
void marqhomot(Image<int>&,Image<int> p_ancr);  

// Squelettisation par points d'ancrage
//                  (Luc Vincent)
 void sqaff(Image<int>& p,Image<int> p_ancr,int a);

//              squelettes MB
void homototo(Image<int>& p,int type);

void mb_directionnel(Image<int>& p);

//             concurrents
 void jangchin(Image<int>& p, int dir);
 void stewart(Image<int>& p);
 void guohall(Image<int>& p,int type);
 void latecki(Image<int>& p,int type);    

// Ebarbulage

 void ebarbule(Image<int>& p);

// Calcul pour anticiper les collisions de CC

 void pare_chocs4(Image<int>& p,Image<int> p_cx,int n);

// Squelette par Zones d'Influence

void Skiz(Image<int>& p,int n);

#endif
